# -*- coding: utf-8 -*-
#    Copyright 2005 Spike^ekipS <spikeekips@gmail.com>
#
#       This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import os
import gtk
import Conf__, Handler, Conf_i18n

DIR_HOME = os.getenv("HOME")

# DEFAULT FILES
FILE_BOOKMARK = os.path.join( \
	DIR_HOME, Conf__.DIR_LOCAL, "bookmark.xml")
FILE_COMMAND = os.path.join( \
	DIR_HOME, Conf__.DIR_LOCAL, "command.xml")

# GLADE FILES ###############################################################
__FILES_GLADE = { \
	"bookmark_property_category"        : "bookmark_property_category.glade", \
	"bookmark_property_ssh"             : "bookmark_property_ssh.glade", \
	"bookmark_property_ssh_filebrowser" : "bookmark_property_ssh_filebrowser.glade", \
	"bookmark_property_terminal"        : "bookmark_property_terminal.glade", \
	"bookmark_property_vim"             : "bookmark_property_vim.glade", \
	"dialog"                            : "dialog.glade", \
	"menu"                              : "menu.glade", \
	"ssh_filebrowser"                   : "ssh_filebrowser.glade", \
	"widget_repository"                 : "widget_repository.glade", \
	"widget_preference0"                : "widget_preference0.glade", \
	"widget_preference1"                : "widget_preference1.glade", \
	"widget_bookmark_property"          : "widget_bookmark_property.glade", \
	"window"                            : "window.glade", \
}

FILES_GLADE = dict()
for i, j in __FILES_GLADE.items() :
	FILES_GLADE[i] = os.path.join(Conf__.DIR_LIBFILE, j)

FILE_SHORTCUT_LOCAL = os.path.join( \
	DIR_HOME, Conf__.DIR_LOCAL, "shortcut_local.xml")
FILE_SHORTCUT_REMOTE = os.path.join( \
	DIR_HOME, Conf__.DIR_LOCAL, "shortcut_remote-%s.xml")
FILE_GCONF_SCHMEA = os.path.join(Conf__.DIR_LIBFILE, "vee.schema")
FILE_GTKRC = os.path.join(Conf__.DIR_LIBFILE, ".gtkrc-2.0")

# GTKRC
TEMPLATE_GTKRC = \
"""
style "vee"
{
    font_name = "@@FONTNAME@@"
}

class "GtkWidget" style "vee"
"""

# ABOUT GCONF
GCONF_APP_DIR	=	"/apps/vee/"

TREEVIEW_TREE_PANEL_COLUMN_ICON = 0
TREEVIEW_TREE_PANEL_COLUMN_NAME = 1


TREEVIEW_PREFERENCES_SHORTCUT_COLUMN_LABEL = 0
TREEVIEW_PREFERENCES_SHORTCUT_COLUMN_KEY = 1
TREEVIEW_PREFERENCES_SHORTCUT_COLUMN_UID = 2

TREEVIEW_FILELIST_PANEL_COLUMN_ICON = 0
TREEVIEW_FILELIST_PANEL_COLUMN_NAME = 1
TREEVIEW_FILELIST_PANEL_COLUMN_SIZE = 2
TREEVIEW_FILELIST_PANEL_COLUMN_PERMISSION = 3
TREEVIEW_FILELIST_PANEL_COLUMN_CREATED_TIME = 4
TREEVIEW_FILELIST_PANEL_COLUMN_PERMISSION_BIN = 5
TREEVIEW_FILELIST_PANEL_COLUMN_FULL_PATH = 6

TREEVIEW_FILE_TRANSFER_STATUS_PANEL_COLUMN_DIRECTION = 0
TREEVIEW_FILE_TRANSFER_STATUS_PANEL_COLUMN_ICON = 1
TREEVIEW_FILE_TRANSFER_STATUS_PANEL_COLUMN_FILEPATH = 2
TREEVIEW_FILE_TRANSFER_STATUS_PANEL_COLUMN_FILE_SIZE = 3
TREEVIEW_FILE_TRANSFER_STATUS_PANEL_COLUMN_TIME_LEFT = 4
TREEVIEW_FILE_TRANSFER_STATUS_PANEL_COLUMN_PERCENT = 5
TREEVIEW_FILE_TRANSFER_STATUS_PANEL_COLUMN_SPEED = 6
TREEVIEW_FILE_TRANSFER_STATUS_PANEL_COLUMN_LOCAL_FILEPATH = 7
TREEVIEW_FILE_TRANSFER_STATUS_PANEL_COLUMN_UID = 8

TREEVIEW_PREFERENCE_PANEL_COLUMN_NAME = 0
TREEVIEW_PREFERENCE_PANEL_COLUMN_UID = 1

TREEVIEW_BOOKMARK_PANEL_COLUMN_ICON = 0
TREEVIEW_BOOKMARK_PANEL_COLUMN_NAME = 1
TREEVIEW_BOOKMARK_PANEL_COLUMN_UID = 2

TREEVIEW_SHORTCUT_PANEL_COLUMN_ICON = 0
TREEVIEW_SHORTCUT_PANEL_COLUMN_NAME = 1
TREEVIEW_SHORTCUT_PANEL_COLUMN_VALUE = 2
TREEVIEW_SHORTCUT_PANEL_COLUMN_UID = 3

COMBOBOX_INITIAL_MODULE_NONE = 0
COMBOBOX_INITIAL_MODULE_VIM = 1
COMBOBOX_INITIAL_MODULE_TERMINAL = 2

# icons for child.
ICONS = { \
	"ssh" : ["gnome-stock-connect", "gnome-stock-linein", "gnome-fs-network"], \
	"ssh_filebrowser" : ["gnome-stock-linein", "gnome-fs-network"], \
	"vim" : ["gtk-bold", "gtk-dnd"], \
	"terminal" : ["gnome-fs-client", ""], \
	"__default__" : ["gtk-missing-image", ], \
	"category" : ["gnome-fs-directory",], \
	"external_command" : ["gtk-convert",], \
	"directory" : ["gnome-fs-directory",], \
	"file" : ["gtk-file",], \
	"link" : ["gnome-dev-symlink",], \
	"up" : ["gtk-go-up",], \
	"down" : ["gtk-go-down",], \
}

BUTTONLIST_ADDITIONAL = ( \
	{ \
		"label" : "open ssh filebrowser tab", \
		"tooltip" : "open ssh filebrowser tab", \
		"image" : gtk.STOCK_NETWORK, \
		"handler" : "on_open_ssh_filebrowser_tab", \
	}, \
	{ \
		"label" : "open ssh tab", \
		"tooltip" : "open ssh tab", \
		"image" : gtk.STOCK_BOLD, \
		"handler" : "on_open_ssh_tab", \
	}, \
)

MENU_ITEM_MAIN = { \
	"vim" : { \
		"widget_name" : "child_vim",
		"stock" : "gtk-select-color", \
		"labelname" : "VIM",
		"handler" : "on_insert_vim", \
	}, \
	"terminal" : { \
		"widget_name" : "child_terminal",
		"stock" : "gtk-select-font", \
		"labelname" : "Terminal",
		"handler" : "on_insert_terminal", \
	}, \
	"ssh" : { \
		"widget_name" : "child_ssh",
		"stock" : "gtk-convert", \
		"labelname" : "SSH",
		"handler" : "on_insert_ssh", \
	}, \
	"ssh_filebrowser" : { \
		"widget_name" : "child_ssh_filebrowser",
		"stock" : "gtk-go-down", \
		"labelname" : "SSH FileBrowser",
		"handler" : "on_insert_ssh_filebrowser", \
	}, \
}

# ssh session type
SSH_SESSION_SFTP = 100
SSH_SESSION_SESSION = 200

# DEFAULT KEYBOARD SHORTCUT
# GTK MODIFIER MASK list
NULL_MODIFIER_MASK = 0

AVAILABLE_MODIFIER_MASK = \
	gtk.gdk.SHIFT_MASK | \
	gtk.gdk.LOCK_MASK | \
	gtk.gdk.CONTROL_MASK | \
	gtk.gdk.MOD1_MASK | \
	gtk.gdk.MOD2_MASK | \
	gtk.gdk.MOD3_MASK | \
	gtk.gdk.MOD4_MASK | \
	gtk.gdk.MOD5_MASK
	#gtk.gdk.BUTTON1_MASK | \
	#gtk.gdk.BUTTON2_MASK | \
	#gtk.gdk.BUTTON3_MASK | \
	#gtk.gdk.BUTTON4_MASK | \
	#gtk.gdk.BUTTON5_MASK | \
	#gtk.gdk.RELEASE_MASK | \
	#gtk.gdk.MODIFIER_MASK

UPPER_SYMBOLS = { \
	"exclam" : "1",                 	"braceleft" : "7", \
	"numbersign" : "3",             	"Control_underscore" : "7", \
	"percent" : "5",                	"asterisk" : "8", \
	"asciicircum" : "6",            	"bracketleft" : "8", \
	"plus" : "equal",               	"Delete" : "8", \
	"braceleft" : "bracketleft",    	"parenleft" : "9", \
	"colon" : "semicolon",          	"bracketright" : "9", \
	"quotedbl" : "apostrophe",      	"parenright" : "0", \
	"asciitilde" : "grave",         	"braceright" : "0", \
	"bar" : "backslash",            	"underscore" : "minus", \
	"less" : "comma",               	"backslash" : "minus", \
	"greater" : "period",           	"Control_underscore" : "minus", \
	"question" : "slash",           	"Control_underscore" : "minus", \
	"dollar" : "4",                 	"braceright" : "bracketright", \
	"Control_backslash" : "4",      	"asciitilde" : "bracketright", \
	"at" : "2",                     	"Control_bracketright" : "bracketright", \
	"nul" : "2",                    	"greater" : "less", \
	"ampersand" : "7",              	"bar" : "less", \
}

LIST_KEYBOARD_SHORTCUT = {
	"keyboard_shortcut_next_tab" : ("<Control>Page_Up" , "self.ac_next_tab "),
	"keyboard_shortcut_prev_tab" : ("<Control>Page_Down" , "self.ac_previous_tab"),
	"keyboard_shortcut_increase_font" : ("<Control>equal" , "self.ac_font_increase "),
	"keyboard_shortcut_decrease_font" : ("<Control>minus" , "self.ac_font_decrease "),

	"keyboard_shortcut_insert_ssh" : ("<Control><Shift>S" , "self.ac_insert_ssh "),
	"keyboard_shortcut_insert_vim" : ("<Control><Shift>V" , "self.ac_insert_vim "),
	"keyboard_shortcut_insert_terminal" : ("<Control><Shift>Z" , "self.ac_insert_terminal "),

	"keyboard_shortcut_run_external_command_dialog" : \
		("<Control><Shift>C" , "self.ac_run_on_external_command"),
	"keyboard_shortcut_focus_external_command_entry" : \
		("<Control><Shift>L" , "self.ac_focus_on_external_command"),
	"keyboard_shortcut_mainwindow_quit" : ("<Control>Q" , "self.on_quit"),
	"keyboard_shortcut_tab_close" : ("<Control><Alt>W" , "self.on_close"),
	"keyboard_shortcut_modifier_switch_tab" : ("<Alt>%d", "self.ac_change_nth_tab"),
	"keyboard_shortcut_toggle_bookmark_panel" : ("<Ctrl><Alt>b", "self.ac_toggle_bookmark"),
	"keyboard_shortcut_toggle_full_screen" : ("F11", "self.ac_toggle_full_screen"),
	"keyboard_shortcut_dashboard" : ("F12", "self.ac_dashboard"),
}

KEYBOARD_SHORTCUT_LIST_FOR_TREEVIEW = { \
	"Execute" : ( \
		("keyboard_shortcut_insert_vim", "Run VIM", ), \
		("keyboard_shortcut_insert_terminal", "Run Terminal", ), \
		("keyboard_shortcut_insert_ssh", "Open new SSH client", ), \
	), \
	"Management" : ( \
		("keyboard_shortcut_mainwindow_quit", "Quit VEE", ), \
		("keyboard_shortcut_tab_close", "Close tab", ), \

		("keyboard_shortcut_dashboard", "View dashboard", ), \
		("keyboard_shortcut_toggle_bookmark_panel", "Toggle bookmark panel", ), \
		("keyboard_shortcut_toggle_full_screen", "Toggle fullscreen", ), \

		("keyboard_shortcut_next_tab", "Go next tab", ), \
		("keyboard_shortcut_prev_tab", "Go previous tab", ), \
		("keyboard_shortcut_increase_font", "Increase font size", ), \
		("keyboard_shortcut_decrease_font", "Decrease font size", ), \

		("keyboard_shortcut_run_external_command_dialog", \
			"Run the external command dialog", ), \
		("keyboard_shortcut_focus_external_command_entry", \
			"Focus in the external command entry", ), \
	),
}

NOTEBOOK_REMOVE_OFFSET = -1

MAP_WIDGET = { \
	"vee" : { \
		"root" : None, \
		"handler" : Handler.MAIN_WINDOW, \
		"handler-signal" : "", \
		"glade-file" : "window", \
		"message" : Conf_i18n.LABEL_VEE, \
	},
	"connection_ssh" : { \
		"root" : None, \
		"handler" : Handler.CONNECTION_SSH, \
		"handler-signal" : dict(), \
		"glade-file" : "window", \
		"message" : Conf_i18n.LABEL_CONNECTION_SSH, \
	},

	"bookmark_property_category" : { \
		"root" : None, \
		"handler" : Handler.PROPERTY_BOOKMARK_CATEGORY, \
		"handler-signal" : dict(), \
		"glade-file" : "bookmark_property_category", \
		"message" : Conf_i18n.LABEL_BOOKMARK_PROPERTY_CATEGORY, \
	},
	"bookmark_property_ssh" : { \
		"root" : None, \
		"handler" : Handler.PROPERTY_BOOKMARK_SSH, \
		"handler-signal" : dict(), \
		"glade-file" : "bookmark_property_ssh", \
		"message" : Conf_i18n.LABEL_BOOKMARK_PROPERTY_SSH, \
	},
	"bookmark_property_ssh_filebrowser" : { \
		"root" : None, \
		"handler" : Handler.PROPERTY_BOOKMARK_SSH_FILEBROWSER, \
		"handler-signal" : dict(), \
		"glade-file" : "bookmark_property_ssh_filebrowser", \
		"message" : Conf_i18n.LABEL_BOOKMARK_PROPERTY_SSH_FILEBROWSER, \
	},
	"bookmark_property_terminal" : { \
		"root" : None, \
		"handler" : Handler.PROPERTY_BOOKMARK_TERMINAL, \
		"handler-signal" : dict(), \
		"glade-file" : "bookmark_property_terminal", \
		"message" : Conf_i18n.LABEL_BOOKMARK_PROPERTY_TERMINAL, \
	},
	"bookmark_property_vim" : { \
		"root" : None, \
		"handler" : Handler.PROPERTY_BOOKMARK_VIM, \
		"handler-signal" : dict(), \
		"glade-file" : "bookmark_property_vim", \
		"message" : Conf_i18n.LABEL_BOOKMARK_PROPERTY_VIM, \
	},

	"preferences" : { \
		"root" : None, \
		"handler" : Handler.PREFERENCES, \
		"handler-signal" : dict(), \
		"glade-file" : "window", \
		"message" : Conf_i18n.LABEL_PREFERENCES, \
	},
	"filechooser_file_logging" : { \
		"root" : None, \
		"handler" : Handler.FILEDIALOG_FILELOGGING, \
		"handler-signal" : dict(), \
		"glade-file" : "dialog", \
		"message" : Conf_i18n.LABEL_FILECHOOSER_FILE_LOGGING, \
	},
	"external_command" : { \
		"root" : None, \
		"handler" : Handler.EXTERNAL_COMMAND, \
		"handler-signal" : dict(), \
		"glade-file" : "window", \
		"message" : Conf_i18n.LABEL_EXTERNAL_COMMAND, \
	},
	"filechooser_select_file_and_directory" : { \
		"root" : None, \
		"handler" : Handler.FILECHOOSER_SELECT_FILE_AND_DIRECTORY, \
		"handler-signal" : dict(), \
		"glade-file" : "dialog", \
		"message" : Conf_i18n.LABEL_FILECHOOSER_SELECT_FILE_AND_DIRECTORY, \
	},
	"menu_main" : { \
		"root" : None, \
		"handler" : Handler.MENU_MAIN, \
		"handler-signal" : dict(), \
		"glade-file" : "menu", \
		"message" : Conf_i18n.LABEL_MENU_MAIN, \
	},

	"button_label_and_image" : { \
		"root" : None, \
		"handler" : dict(), \
		"handler-signal" : dict(), \
		"glade-file" : "widget_repository", \
		"message" : Conf_i18n.LABEL_VEE, \
	},
	"button_label" : { \
		"root" : None, \
		"handler" : dict(), \
		"handler-signal" : dict(), \
		"glade-file" : "widget_repository", \
		"message" : None, \
	},
	"button_image" : { \
		"root" : None, \
		"handler" : dict(), \
		"handler-signal" : dict(), \
		"glade-file" : "widget_repository", \
		"message" : None, \
	},
	"menu_add_new" : { \
		"root" : None, \
		"handler" : dict(), \
		"handler-signal" : dict(), \
		"glade-file" : "menu", \
		"message" : Conf_i18n.LABEL_MENU_ADD_NEW, \
	},
	"vbox_ssh_filebrowser" : { \
		"root" : None, \
		"handler" : Handler.SSH_FILEBROWSER, \
		"handler-signal" : dict(), \
		"glade-file" : "ssh_filebrowser", \
		"message" : Conf_i18n.LABEL_SSH_FILEBROWSER, \
	},
	"quit" : { \
		"root" : None, \
		"handler" : None, \
		"handler-signal" : dict(), \
		"glade-file" : "window", \
		"message" : Conf_i18n.LABEL_QUIT, \
	},
	"box_preference_terminal" : { \
		"root" : None, \
		"handler" : None, \
		"handler-signal" : dict(), \
		"glade-file" : "widget_preference1", \
		"message" : Conf_i18n.LABEL_WIDGET_PREFERENCES1, \
	},
	"box_preference_vim" : { \
		"root" : None, \
		"handler" : None, \
		"handler-signal" : dict(), \
		"glade-file" : "widget_preference1", \
		"message" : Conf_i18n.LABEL_WIDGET_PREFERENCES1, \
	},
	"box_preference_external_command" : { \
		"root" : None, \
		"handler" : None, \
		"handler-signal" : dict(), \
		"glade-file" : "widget_preference1", \
		"message" : Conf_i18n.LABEL_WIDGET_PREFERENCES1, \
	},
	"box_preference_ssh" : { \
		"root" : None, \
		"handler" : None, \
		"handler-signal" : dict(), \
		"glade-file" : "widget_preference1", \
		"message" : Conf_i18n.LABEL_WIDGET_PREFERENCES1, \
	},
	"box_preference_ssh_filebrowser" : { \
		"root" : None, \
		"handler" : None, \
		"handler-signal" : dict(), \
		"glade-file" : "widget_preference1", \
		"message" : Conf_i18n.LABEL_WIDGET_PREFERENCES1, \
	},
	"box_preference_font" : { \
		"root" : None, \
		"handler" : None, \
		"handler-signal" : dict(), \
		"glade-file" : "widget_preference0", \
		"message" : Conf_i18n.LABEL_WIDGET_PREFERENCES0, \
	},
	"box_preference_color" : { \
		"root" : None, \
		"handler" : None, \
		"handler-signal" : dict(), \
		"glade-file" : "widget_preference0", \
		"message" : Conf_i18n.LABEL_WIDGET_PREFERENCES0, \
	},
	"box_preference_background" : { \
		"root" : None, \
		"handler" : None, \
		"handler-signal" : dict(), \
		"glade-file" : "widget_preference0", \
		"message" : Conf_i18n.LABEL_WIDGET_PREFERENCES0, \
	},
	"box_preference_etc" : { \
		"root" : None, \
		"handler" : None, \
		"handler-signal" : dict(), \
		"glade-file" : "widget_preference0", \
		"message" : Conf_i18n.LABEL_WIDGET_PREFERENCES0, \
	},
	"bookmark_property_frame_font" : { \
		"root" : None, \
		"handler" : None, \
		"handler-signal" : dict(), \
		"glade-file" : "widget_bookmark_property", \
		"message" : Conf_i18n.LABEL_BOOKMARK_PROPERTY_VTE, \
	},
	"bookmark_property_frame_color" : { \
		"root" : None, \
		"handler" : None, \
		"handler-signal" : dict(), \
		"glade-file" : "widget_bookmark_property", \
		"message" : Conf_i18n.LABEL_BOOKMARK_PROPERTY_VTE, \
	},
	"bookmark_property_frame_background" : { \
		"root" : None, \
		"handler" : None, \
		"handler-signal" : dict(), \
		"glade-file" : "widget_bookmark_property", \
		"message" : Conf_i18n.LABEL_BOOKMARK_PROPERTY_VTE, \
	},
	"bookmark_property_frame_etc" : { \
		"root" : None, \
		"handler" : None, \
		"handler-signal" : dict(), \
		"glade-file" : "widget_bookmark_property", \
		"message" : Conf_i18n.LABEL_BOOKMARK_PROPERTY_VTE, \
	},
	"dashboard" : { \
		"root" : None, \
		"handler" : Handler.DASHBOARD, \
		"handler-signal" : None, \
		"glade-file" : "window", \
		"message" : Conf_i18n.LABEL_DASHBOARD, \
	},
	"about" : { \
		"root" : None, \
		"handler" : None, \
		"handler-signal" : None, \
		"glade-file" : "window", \
		"message" : None, \
	},
	"signal_message" : { \
		"root" : None, \
		"handler" : None, \
		"handler-signal" : "", \
		"glade-file" : "dialog", \
		"message" : None, \
	},
}
"""
	"" : { \
		"root" : None, \
		"handler" : None, \
		"handler-signal" : dict(), \
		"glade-file" : "", \
		"message" : Conf_i18n.LABEL_VEE, \

	},
"""

NOTEBOOK_PAGE_FILECHOOSER_SELECT_FILE_AND_DIRECTORY_FILE = 0
NOTEBOOK_PAGE_FILECHOOSER_SELECT_FILE_AND_DIRECTORY_DIRECTORY = 1

NOTEBOOK_PAGE_BOOKMARK_PROPERTY_VTE_FONT = 1
NOTEBOOK_PAGE_BOOKMARK_PROPERTY_VTE_COLOR = 2
NOTEBOOK_PAGE_BOOKMARK_PROPERTY_VTE_BACKGROUND = 3
NOTEBOOK_PAGE_BOOKMARK_PROPERTY_VTE_ETC = 4

PREFERENCE_ITEM = ( \
	("Terminal", "vte", \
		( \
			("Modules", "modules", \
				( \
					("Terminal", "terminal", None), \
					("VIM", "vim", None), \
					("External Command", "external_command", None), \
				), \
			), \
			("Fonts", "font", None), \
			("Background", "background", None), \
			("Colors", "color", None), \
			("Etc", "etc", None), \
		), \
	), \
	("SSH", "ssh", None), \
)

#############################################################
# COMMAND LINE OPTION.
OPTIONS_VEET = { \
	"-v" : ("--as-vim", { \
			"action" : "store_true", \
			"dest" : "ARG_AS_VIM", \
			"default" : False, \
			"help" : "Start with vim. (Default)", \
		}, \
	), \
}

OPTIONS_VEE = { \
	"-V" : ("--start-with-vim", { \
			"action" : "store_true", \
			"dest" : "ARG_START_WITH_VIM", \
			"default" : False, \
			"help" : "Start with vim.", \
		}, \
	), \
	"-S" : ("--start-with-ssh", { \
			"action" : "store_true", \
			"dest" : "ARG_START_WITH_SSH", \
			"default" : False, \
			"help" : "Start with ssh client.", \
		}, \
	), \
	"-T" : ("--start-with-terminal", { \
			"action" : "store_true", \
			"dest" : "ARG_START_WITH_TERMINAL", \
			"default" : False, \
			"help" : "Start with terminal.", \
		}, \
	), \
	"-s" : ("--install-schema", { \
			"action" : "store_true", \
			"dest" : "ARG_INSTALL_SCHEMA", \
			"default" : False, \
			"help" : "Install GConf schema.", \
		}, \
	), \
	"-f" : ("--fullscreen", { \
			"action" : "store_true", \
			"dest" : "ARG_FULLSCREEN_WINDOW", \
			"default" : False, \
			"help" : "Start the window to be fullscreened.", \
		}, \
	), \
	"-t" : ("--hide-toolbar", { \
			"action" : "store_false", \
			"dest" : "ARG_SHOW_TOOLBAR", \
			"default" : True, \
			"help" : "Hide toolbar.", \
		}, \
	), \
	"-x" : ("--maximize", { \
			"action" : "store_true", \
			"dest" : "ARG_MAXIMIZE_WINDOW", \
			"default" : False, \
			"help" : "Start the default window to be maximized.", \
		}, \
	), \
	"-g" : ("--geometry", { \
			"dest" : "ARG_GEOMETRY", \
			"metavar" : "GEOMETRY", \
			"default" : "", \
			"help" : "Set the initial geometry. ex) 500x400+10+10", \
		}, \
	), \
}


GCONF_MONOSPACE_FONT_NAME = "/desktop/gnome/interface/monospace_font_name"
GCONF_GNOME_INTERFACE_FONTNAME = "/desktop/gnome/interface/font_name"

TEMPLATE_RC_FILE = \
"""style \"vee\"
{
    font_name = \"%(fontname)s\"
}

class \"GtkWidget\" style \"vee\"
"""

###############################################################################
# D&D
DND_TARGET_COLOR = 100
DND_TARGET_BGIMAGE = 101
DND_TARGET_RESET_BG = 102
DND_TARGET_URI_LIST = 103
DND_TARGET_MOZ_URL = 104
DND_TARGET_UTF8_STRING = 105
DND_TARGET_COMPOUND_TEXT = 106
DND_TARGET_TEXT_PLAIN = 107
DND_TARGET_STRING = 108
DND_TARGET_TEXT_PLAIN = 109
DND_TARGET_TEXT = 110

# drag and drop target tables, it from terminal-screen.c in
# gnome-terminal.
DND_TARGET_TABLE = [
	( "application/x-color", 0, DND_TARGET_COLOR ),
	( "property/bgimage",    0, DND_TARGET_BGIMAGE ),
	( "x-special/gnome-reset-background", 0, DND_TARGET_RESET_BG ),
	( "text/uri-list",  0, DND_TARGET_URI_LIST ),
	( "text/x-moz-url",  0, DND_TARGET_MOZ_URL ),
	( "UTF8_STRING", 0, DND_TARGET_UTF8_STRING ),
	( "COMPOUND_TEXT", 0, DND_TARGET_COMPOUND_TEXT ),
	( "TEXT", 0, DND_TARGET_TEXT ),
	( "STRING",     0, DND_TARGET_STRING ),
	( "text/plain", 0, DND_TARGET_TEXT_PLAIN )
]

DND_TARGET_TABLE_SSH_FILEBROWSER = [
        ( "text/uri-list",  0, DND_TARGET_URI_LIST ),
]

"""
Description
-----------


ChangeLog
---------


Usage
-----


"""

__author__ =  "Spike^ekipS <spikeekips@gmail.com>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "Conf.py"


