# -*- coding: utf-8 -*-
#    Copyright (C) 2005 Spike^ekipS <spikeekips@gmail.com>
#
#    http://vee.kldp.net
#
#       This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import os, base64, marshal
import child, __VTE__, i18n, __OS__, func

_ = i18n.gettext()

class EGG (__VTE__.EGG) :

	CHILD_TYPE = child.TYPE_SSH
	EXIT_WITHOUT_ENTER = False

	def parse_command (self) :
		__argument = ( \
			self.SETTING["command"], \
			"-c", \
			"conch_vee -U %s" % \
				self.SETTING["file-uid"], \
		)

		return ( \
			self.SETTING["command"], \
			__argument, \
			("UID_VEE=%s" % self.STATE_LOCAL["uid"], ), \
			os.getcwd() \
		)

	TEMPLATE_TITLE_WITH_LABEL = "%s : Connected to %s"
	TEMPLATE_TITLE_WITHOUT_LABEL = "Connected to %s"

	def getTitle (self) :
		"""
		In the remote shell environment, we can not find out exactly which shell
		be using, so we can not use 'PROMPT_COMMAND' environment variable.
		"""

		__title = "Connected to %s@%s" % (self.SETTING["user"], self.SETTING["host"], )
		return __title

class TAB (__VTE__.TAB) :

	def __init__ (self, state, notebook, child, **kwargs) :
		self.STATE = state
		self.STATE_GLOBAL = self.STATE["global"]

		if not kwargs.has_key("file-uid") :
			__tempfile = func.create_uid_tmp( \
				self.STATE_GLOBAL["directory-temp"], kwargs)

			if __tempfile is None :
				raise RuntimeError, "invalid request."

			kwargs.update({"file-uid": __tempfile})

		__VTE__.TAB.__init__(self, state, notebook, child, **kwargs)

	def make (self) :
		__VTE__.TAB.make(self)

		# In SSH, we does not use auto-updating of title.
		if self.EVENT_ID_TITLE_CHANGED :
			self.WIDGET_CHILD.disconnect(self.EVENT_ID_TITLE_CHANGED)

	def getSetting (self) :
		__VTE__.TAB.getSetting(self)

		if not self.SETTING.has_key("command") or \
				(self.SETTING.has_key("command") and \
						not self.SETTING["command"].strip()) :
			self.SETTING["command"] = \
				self.GCONF_CLIENT.getValue("terminal_command")

	def createLabel (self, labelname) :

		if self.SETTING.has_key("label") and self.SETTING["label"].strip() :
			__labelname = self.SETTING["label"]
		else :
			__labelname = "%s@%s" % (self.SETTING["user"], self.SETTING["host"], )

		__VTE__.TAB.createLabel(self, __labelname)

"""
Description
-----------


ChangeLog
---------


Usage
-----


"""

__author__ =  "Spike^ekipS <spikeekips@gmail.com>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "terminal.py"


