# -*- coding: utf-8 -*-
#    Copyright (C) 2005 Spike^ekipS <spikeekips@gmail.com>
#
#    http://vee.kldp.net
#
#       This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import os, base64, marshal
import child, __VTE__, i18n, __OS__, Label

_ = i18n.gettext()

COMMAND_INIT = [ \
	"\033:set title titlestring=%f;;;%t\n:\n\n",
	"\033:set mouse=nvi\n:\n\n",
	"\033:set confirm\n:\n\n",
]

COMMAND_OPEN_FILE = "\033:e %s\n:\n\n"

class EGG (__VTE__.EGG) :

	CHILD_TYPE = child.TYPE_VIM
	FILENAME = ""

	def make (self) :
		__VTE__.EGG.make(self)

		# run initial command inside vim.
		for i in COMMAND_INIT :
			self.WIDGET.feed_child(i)

	def parse_command (self) :
		(__command, __argument, __environment, __directory, ) = \
			__VTE__.EGG.parse_command(self)

		# set base directory and the file(NOT FILES) to be read from vim.
		if self.SETTING.has_key("filename") :
			__directory = os.path.dirname(self.SETTING["filename"])
			if not os.path.isdir(__directory) :
				__directory = os.getenv("HOME")

			# set file
			self.FILENAME = self.SETTING["filename"]
			__argument += (self.SETTING["filename"], )

		return (__command, __argument, __environment, __directory, )

	def getTitle (self) :
		__a = __VTE__.EGG.getTitle(self)
		if not __a : return

		__b = __a.split(";;;")

		if len(__b) < 2 :
			return self.FILENAME
		else :
			__dirname = os.path.dirname(__OS__.normalize_path(__b[0]))
			if not os.path.isdir(__dirname) :
				__title = "".join(__b[1:])
			else :
				self.FILENAME = __b[1]
				__title = __b[0]

		return __title

	def exit (self) :
		__VTE__.EGG.exit(self)

	def on_drag_received \
			(self, widget, context, x, y, selection, targetType, time) :

		__path = __OS__.get_filename_from_uri(selection.data)
		self.WIDGET.feed_child(COMMAND_OPEN_FILE % __path)

		return True

class TAB (__VTE__.TAB) :

	def getSetting (self) :
		__VTE__.TAB.getSetting(self)

		if not self.SETTING.has_key("command") :
			self.SETTING["command"] = self.GCONF_CLIENT.getValue("vim_command")

	def createLabel (self, labelname) :
		if self.SETTING.has_key("label") :
			__labelname = self.SETTING["label"]
		else :
			if not self.SETTING.has_key("filename") :
				__labelname = "VIM"
			else :
				__labelname = self.SETTING["filename"]

		print __labelname
		__VTE__.TAB.createLabel(self, __labelname)

"""
Description
-----------


ChangeLog
---------


Usage
-----


"""

__author__ =  "Spike^ekipS <spikeekips@gmail.com>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "vim.py"


