# -*- coding: utf-8 -*-
#    Copyright (C) 2005 Spike^ekipS <spikeekips@gmail.com>
#
#    http://vee.kldp.net
#
#       This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import sys, sre, os, glob
import gtk

import i18n
_ = i18n.gettext()

import time, random, socket, md5, xmlrpclib
def get_uid (args=str()) :
	"""
	Generates a universally unique ID.
	Any arguments only create more randomness.

	----------------------------------------------------------------------
	Written by Carl Free Jr.
	url : http://aspn.activestate.com/ASPN/Cookbook/Python/Recipe/213761
	----------------------------------------------------------------------
	"""

	t = long( time.time() * 1000 )
	r = long( random.random()*100000000000000000L )
	try:
		a = socket.gethostbyname( socket.gethostname() )
	except:
		# if we can't get a network address, just imagine one
		a = random.random() * 100000000000000000L
	data = str(t) + ' ' + str(r) + ' ' + str(a) + ' ' + args
	data = md5.md5(data).hexdigest()
	return data

def get_new_vee_id (VEE_IDS=dict()) :
	if len(VEE_IDS) < 1 : return 0

	b = VEE_IDS.keys()

	b.sort()

	return int(b.pop()) + 1

def color_to_str (gdkColor) :
	if not isinstance(gdkColor, gtk.gdk.Color) :
		raise ValueError, \
			"gdkColor must be the instance of gtk.gdk.Color."

	color = "#%2X%2X%2X" % ( \
		gdkColor.red / 256, \
		gdkColor.green / 256, \
		gdkColor.blue / 256, \
	)

	return color.replace(" ", "0")

def str_to_color (color_spec, default="white") :
	try :
		return gtk.gdk.color_parse(color_spec)
	except ValueError :
		return gtk.gdk.color_parse(default)
	except TypeError :
		return None

def get_striped_labelname (label_name, size=10) :
	if label_name.count(os.sep) < 1 and size is not None:
		try :
			return label_name[-size:]
		except IndexError :
			return label_name
	else :
		__filename = os.path.basename(label_name)
		__pathname = os.path.dirname(label_name)

		if len(__filename) >= size or size is None :
			return __filename
		else :
			__a = __pathname[-(size - len(__filename)):]

			return os.path.join(__a, __filename)

def get_list_of_vee () :
	a, b, c = os.popen3("ps aux | grep python | grep vee | grep -v grep | awk '{print $2}'")

	return [i.strip() for i in b.readlines()]

import sre
def is_ip_address (ip_address) :
	if sre.compile( \
				"[0-9][0-9]*\.[0-9][0-9]*\.[0-9][0-9]*\.[0-9][0-9]*" \
				).findall(ip_address.strip()) :
		return True
	else :
		return False

import socket
def is_valid_ip_address (ip_address) :
	try :
		socket.inet_aton(ip_address.strip())
	except socket.error :
		return False
	else :
		return True

def create_icon (icon_file_path, w=30, h=30) :
	"""
	@return pixbuf image.
	"""
	if not os.path.isfile(icon_file_path) :
		return None

	__i = gtk.Image()
	__i.set_from_file(icon_file_path)
	__i.set_property("icon-size", 0)

	__image = __i.get_pixbuf().scale_simple(w, h, 2)

	return __image

def casting (type, value) :

	if type == "str" :
		return str("%s" % value)
	elif type == "int" :
		if not value :
			return int()
		else :
			value = str(value)
			return int(value.split(".")[:1][0])
	elif type == "float" :
		if not value :
			return float()
		else :
			return float("%s" % value)
	elif type == "bool" :
		return bool(value)
	else :
		return value

def get_formatted_time (timestamp, format="") :
	try :
		timestamp = int(timestamp)
	except ValueError :
		return ""
	except TypeError :
		return ""

	if not format.strip() : format = "Today %-I:%M:%S %p"

	format = sre.compile("today",sre.IGNORECASE).sub(_("Today"), format)

	return time.strftime(format, time.localtime(timestamp))

import time, datetime
def timediff (timestamp) :
	"""
	Get the elapsed time by seconds.
	"""

	__a = datetime.timedelta(seconds=int(time.time()) - timestamp)

	h = 0; m = 0; s = 0

	__hours = __a.seconds / (60 * 60)
	if __hours < 1 :
		__min = __a.seconds
	else :
		h = __hours
		__min = __a.seconds % (60 * 60)

	__min = __min / 60
	if __min < 1 :
		s = __a.seconds
	else :
		m = __min
		s = __a.seconds % 60

	return (__a.days, h, m, s, )

def get_elapsed_time (timestamp) :
	"""
	Calculate the elapsed time.
	@return : ()
	"""

	try :
		timestamp = int(timestamp)
	except ValueError :
		return ""
	except TypeError :
		return ""

	(__d, __h, __m, __s) = timediff(timestamp)

	__Y = 0
	__M = 0
	if __d > 365 :
		__Y = int(__d / 365)
		__d = __d % 365

	if __d > 30 : # or 31?
		__M = int(__d / 30)
		__d = int(__d % 30)

	__time = list()
	if __d < 1 and __h < 1 and __m < 1 :
		__time.append(_("%d seconds") % __s)

	if __m > 0 :
		__time.append(_("%d minutes") % __m)
	if __h > 0 : __time.append(_("%d hours") % __h)
	if __d > 0 : __time.append(_("%d days") % __d)
	if __M > 0 : __time.append(_("%d months") % __M)
	if __Y > 0 : __time.append(_("%d years") % __Y)

	__time.reverse()
	return _("%s ago") % (" ".join(__time))

import gtk
def get_pixbuf_filled_with_color (spec, (width, height,)) :
	"""
	Create a gtk.Image object, which was filled with one color.
	If spec is None, fully transparent pixbuf will be returned.

	@args :
		str spec : a string containing a color specification
		int width : image width
		int height : image height

	@return : gtk.gdk.Pixbuf
	"""

	__is_alpha = False

	colormap = gtk.gdk.colormap_get_system()
	try :
		__color = colormap.alloc_color(gtk.gdk.color_parse(spec))
	except ValueError :
		__is_alpha = True
	except TypeError :
		__is_alpha = True

	if __is_alpha :
		__color = colormap.alloc_color(gtk.gdk.color_parse("#FFFFFF"))

	__gdk_image = gtk.gdk.Image( \
		gtk.gdk.IMAGE_FASTEST, gtk.gdk.visual_get_best(), width, height)
	for i in range(width) :
		for j in range(height) :
			__gdk_image.put_pixel(i, j, long(__color.pixel))

	__pixbuf = gtk.gdk.Pixbuf(gtk.gdk.COLORSPACE_RGB, True, 8, width, height)
	__pixbuf.get_from_image(__gdk_image, colormap, 0, 0, 0, 0, width, height)

	if __is_alpha :
		__pixbuf = __pixbuf.add_alpha(True, chr(0xFF),chr(0xFF),chr(0xFF))

	return __pixbuf


# GTK MODIFIER MASK list
NULL_MODIFIER_MASK = 0

AVAILABLE_MODIFIER_MASK = \
	gtk.gdk.SHIFT_MASK | \
	gtk.gdk.LOCK_MASK | \
	gtk.gdk.CONTROL_MASK | \
	gtk.gdk.MOD1_MASK | \
	gtk.gdk.MOD2_MASK | \
	gtk.gdk.MOD3_MASK | \
	gtk.gdk.MOD4_MASK | \
	gtk.gdk.MOD5_MASK
	#gtk.gdk.BUTTON1_MASK | \
	#gtk.gdk.BUTTON2_MASK | \
	#gtk.gdk.BUTTON3_MASK | \
	#gtk.gdk.BUTTON4_MASK | \
	#gtk.gdk.BUTTON5_MASK | \
	#gtk.gdk.RELEASE_MASK | \
	#gtk.gdk.MODIFIER_MASK

UPPER_SYMBOLS = { \
	"exclam" : "1",                 	"braceleft" : "7", \
	"numbersign" : "3",             	"Control_underscore" : "7", \
	"percent" : "5",                	"asterisk" : "8", \
	"asciicircum" : "6",            	"bracketleft" : "8", \
	"plus" : "equal",               	"Delete" : "8", \
	"braceleft" : "bracketleft",    	"parenleft" : "9", \
	"colon" : "semicolon",          	"bracketright" : "9", \
	"quotedbl" : "apostrophe",      	"parenright" : "0", \
	"asciitilde" : "grave",         	"braceright" : "0", \
	"bar" : "backslash",            	"underscore" : "minus", \
	"less" : "comma",               	"backslash" : "minus", \
	"greater" : "period",           	"Control_underscore" : "minus", \
	"question" : "slash",           	"Control_underscore" : "minus", \
	"dollar" : "4",                 	"braceright" : "bracketright", \
	"Control_backslash" : "4",      	"asciitilde" : "bracketright", \
	"at" : "2",                     	"Control_bracketright" : "bracketright", \
	"nul" : "2",                    	"greater" : "less", \
	"ampersand" : "7",              	"bar" : "less", \
}

import sre
def get_keyname (event, **kwargs) :
	"""
	Keyword arguments,
		ignore_shift
			: when typing a upper letter, ignore <Shift>.
	"""

	__IS_IGNORE_SHIFT = False
	if kwargs.has_key("ignore_shift") and kwargs["ignore_shift"] :
		__IS_IGNORE_SHIFT = True

	__keyval_name = gtk.gdk.keyval_name(event.keyval)

	#__mod = event.state & gtk.gdk.MODIFIER_MASK
	__mod = event.state & AVAILABLE_MODIFIER_MASK
	if __mod == NULL_MODIFIER_MASK :
		return __keyval_name

	if not __keyval_name : return ""
	if not __keyval_name.strip() : return ""

	if not gtk.accelerator_valid(event.keyval, event.state) :
		return ""

	# check the symbols caused by SHIFT key.
	__key_string = gtk.gdk.keyval_name(event.keyval)
	if UPPER_SYMBOLS.has_key(__key_string) :
		mods = event.state & ~ gtk.gdk.SHIFT_MASK
	else :
		if __IS_IGNORE_SHIFT and \
				sre.compile("[a-zA-Z]").findall(__key_string.lower()) :
			mods = event.state
			if mods == gtk.gdk.SHIFT_MASK :
				return __key_string.lower()
		else :
			mods = event.state

	# store key event.
	if len(__key_string) == 1 : __key_string = __key_string.upper()

	__key_name = gtk.accelerator_name(event.keyval, mods)

	# filtering the close this window.
	if not mods :
		__key_value = __key_string
	else :
		__key_value = ">".join(__key_name.split(">")[:-1]) + ">" + \
			__key_string

	return __key_value

import Conf__, pickle
def get_pickle_data_for_ssh (uid) :
	__directory_tmp = os.path.join(Conf__.DIR_LOCAL, "tmp")
	if not os.path.exists(os.path.join(__directory_tmp, uid)) :
		return None
	else :
		__fd = file(os.path.join(__directory_tmp, uid), "r")
		__obj = pickle.load(__fd)
		__fd.close()

		return __obj

def save_pickle_data_for_ssh (obj) :
	uid = get_uid()

	__directory_tmp = \
		os.path.join(os.getenv("HOME"), Conf__.DIR_LOCAL, "tmp")
	while os.path.exists(os.path.join(__directory_tmp, uid)) :
		# get new uid.
		uid = get_uid()

	__fd = file(os.path.join(__directory_tmp, uid), "w")
	__obj = pickle.dump(obj, __fd)
	__fd.close()

	return uid

import time
def print_message (msg, type="error") :
	tmpl_msg = "%s - (%s) %s"
	__date = time.strftime("%c")

	if type == "info" :
		__type = "II"
	else :
		__type = "WW"

	return tmpl_msg % (__date, __type, msg)

def format_log_string (label_widget, message, type="error") :

	label_widget.set_property("use-markup", True)

	if type == "info" :
		__message = "<span size=\"small\">%s</span>" % message
	else :
		__message = "<span size=\"small\" foreground=\"#DA3C14\">%s</span>" % message

	label_widget.set_markup(__message)

def change_saturation (pixbuf, saturate=0.5, pixelize=False) :
	__dest = pixbuf.copy()
	pixbuf.saturate_and_pixelate(__dest, 0.1, pixelize)

	return __dest


import tempfile, pickle
def create_uid_tmp (temp_directory, data=dict()) :
	try:
		__tempfile = tempfile.mktemp(dir=temp_directory)
		__fd = file(__tempfile, "w")
		pickle.dump(data, __fd)
		__fd.close()
	except IOError :
		return None

	return __tempfile

RETVAL_UID_HOST_INVALID = -4
RETVAL_UID_IP_ADDRESS_INVALID = -3
def check_uid_data (data) :
	__new = dict()

	if not data["host"].strip() :
		return RETVAL_UID_HOST_INVALID

	if not is_ip_address(data["host"]) :
		__new["host"] = data["host"]
	else :
		if not is_valid_ip_address(data["host"]) :
			return RETVAL_UID_IP_ADDRESS_INVALID
		else :
			__new["host"] = data["host"]

	if not data["user"].strip() :
		__new["user"] = os.getenv("USER")
	else :
		__new["user"] = data["user"]

	try :
		__new["port"] = int(data["port"])
	except ValueError :
		__new["port"] = 22

	if data["ssh_version"] == 0 :
		__new["ssh_version"] = 2
	elif data["ssh_version"] == 1 :
		__new["ssh_version"] = 1
	else :
		__new["ssh_version"] = 2

	return __new

def parse_argument_of_veet (data) :
	__a = xmlrpclib.loads(data)

	if len(__a[0]) < 2 :
		__uid = None
	else :
		__uid = __a[0][1]

	__data = __a[0][0][1:]

	return (__uid, __data)

import sre, os, __OS__
def get_fontname_from_gtkrc (filename) :
	if not __OS__.is_file(filename) :
		return None
	else :
		try :
			a = file(filename, "r")
			b = "".join(a.readlines())
		except :
			return None
		else :
			try :
				return sre.compile( \
					"font_name", sre.IGNORECASE).sub( \
						"", sre.compile( \
							"font_name = [\"'][a-z0-9 ][a-z0-9 ]*[\"']", \
							sre.IGNORECASE).findall( \
								b.replace(os.linesep, ""))[0]).replace( \
									"=", "").replace( \
										"\"", "").replace( \
											"'", "").strip()
			except :
				return None


import Conf
def save_fontname_in_gtkrc (fontname, filename) :
	try :
		__f = file(filename, "w")
		__f.write(Conf.TEMPLATE_GTKRC.replace("@@FONTNAME@@", fontname))
		__f.close()
	except IOError :
		return False

	return True

"""
Description
-----------


ChangeLog
---------


Usage
-----


"""

__author__ =  "Spike^ekipS <spikeekips@gmail.com>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "func.py"


