#!/usr/bin/env python
# -*- coding: utf-8 -*-
#    Copyright (C) 2005 Spike^ekipS <spikeekips@gmail.com>
#
#    http://vee.kldp.net
#
#       This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import sys, os

# for scp client.
try :
	from twisted.internet import gtk2reactor
	gtk2reactor.install()

	from twisted.internet import reactor
except ImportError, msg :
	print "==========================================="
	print "(WW) %s" % msg
	print "You must install twisted python(>= 2.0)."
	sys.exit(1)

import pygtk
pygtk.require("2.0")

import i18n
_ = i18n.gettext()

try :
	import gtk, gnome
except :
	print _("You need to install pygtk or GTKv2 and PyGnome.")
	sys.exit(1)

import Conf, Conf__, XMLHandler, Window, Options, GConf, func, State, \
	GNOME, WIDGET

if __name__ == "__main__" :

	# parse command-line argument.
	__parser = Options.VEE()
	(__OPTIONS, __ARGS) = __parser.parse_args()

	# check options and print error.
	if __OPTIONS.ARG_GEOMETRY :
		if not WIDGET.parse_geometry(__OPTIONS.ARG_GEOMETRY) :
			__parser.error(_("Invalid '--geometry' value, %s") % __OPTIONS.ARG_GEOMETRY)

	state_global = State.VEE()
	state_global.set_value("list-vee", list())

	if __OPTIONS.ARG_INSTALL_SCHEMA :
		GConf.verify(True)

	if not GConf.verify() :
		print "(WW) invalid gconf schema. Check gconf."
		__parser.print_help()
		sys.exit(1)

	try :
		gconf_client = GConf.Client(Conf.GCONF_APP_DIR)
	except RuntimeError, msg :
		print "(WW) %s" % msg
		sys.exit(1)
	else :
		state_global.set_value("gconf-client", gconf_client)

	# add bookmark to state_global
	try :
		__bookmark = XMLHandler.Bookmark(Conf.FILE_BOOKMARK)
	except IOError :
		__bookmark = XMLHandler.Bookmark()

	# shortcut
	try :
		__shortcut_local = XMLHandler.Shortcut(Conf.FILE_SHORTCUT_LOCAL)
	except IOError :
		__shortcut_local = XMLHandler.Shortcut()

	# external command
	try :
		__command = XMLHandler.Command(Conf.FILE_COMMAND)
	except IOError :
		__command = XMLHandler.Command()

	state_global.set_value("bookmark", __bookmark)
	state_global.set_value("command", __command)
	state_global.set_value("shortcut-local", __shortcut_local)

	GNOME.program_init( \
		PARAM_APP_DATADIR=Conf__.DIR_SHARE, \
		app_name=Conf__.INFO["name"], \
		version=Conf__.INFO["version"], \
	)

	app = Window.VEE( \
		state_global, args_options=__OPTIONS, args_args=__ARGS)

	try :
		reactor.run()
	except :
		sys.exit(1)
	else :
		sys.exit(0)

"""
Description
-----------


ChangeLog
---------


Usage
-----


"""

__author__ =  "Spike^ekipS <spikeekips@gmail.com>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "vee.py"


